<script setup>
import JzotCreate from '@/components/jzot/JzotCreate.vue'
import JzotBrowse from '@/components/jzot/JzotBrowse.vue'
</script>

<template>
<div>
  <div>
    <JzotCreate :on_browse='() => {state = "browse"}' v-if='state=="add_new" && $store.state.user?.is_superuser'/>

    <JzotCreate :initial_object=record :after_post_callback='afterPostCallback' :on_browse='() => {state = "browse"}' v-else-if='state=="edit" && $store.state.user?.is_superuser' />
    <JzotBrowse :id=id :on_edit='OnChildButtonEdit' :on_add_new='() => {state = "add_new"}' v-else-if='state=="browse"' />
  </div>

  </div>
</template>

<script>
import { setAuthorizationToken } from "../utils/authUtils";
import { getJzotById } from "../utils/apiUtils";

export default {
  name: "Jzot",
  props: {
    id : String,
    inital_state : String
  },
  data: function() {
    return {
      record: null,
      state: "browse",
    };
  },
  methods: {
    afterPostCallback() {
      this.state = "browse";
    },
    OnChildButtonEdit(id) {
      if (id) {
        (async () => {
            setAuthorizationToken(localStorage.getItem("jwtAccessToken"));
            this.record = await getJzotById(id)
            this.state = "edit"
        })();
      }
    }
  },
  mounted: function() {}
};
</script>

<style scoped>

</style>>